/*
atom.dm

This file contains proc definitions for atom-atom interactions.
Whenever an atom interacts with another atom, it works like this:

interactee: the atom who is interacting with another atom
interacted: the atom being interacted with by interactee


interactee.interact(interacted)


interact() calls interacted() in such a way that makes things like NPC interaction easy.


interacted.interacted(interactee)


With this format, you can do something like this:


npc
	interacted(atom/a)
		a << "[src] says:  You interacted with me!"


You can define what happens when an NPC is interacted with inside the NPC itself.  Easy, right?
*/

atom
	proc
		interact(atom/a)
			a.interacted(src)

		interacted(atom/a)