#define DEBUG

/*
_mob.dm
(The underscore makes this file go to the top of the tree, meaning it is compiled before those underneath it.)

This file contains the main definitions for the /mob tree.

Includes:
	- All variables
	- Stat()
	- Bump()
		: In this framework, bumping a mob attacks.  It won't be hard to change this.  Just remember to call attacker.attack(victim).
	- key_down()
		: This handles the "hotkeys" for doing things, like Space for talking, G for Get, etc...

*/



mob
	icon = '\Icons/mob.dmi'

	var
		hit_points = 50

		strength = 10

		mana = 10

		defense = 10

		// Accuracy and Agility are in percentages.
		accuracy = 0.75

		// They directly relate to one another.  They should both add up to be 1(100%).
		agility = 0.25

		gold = 0

		bag_control/bag

		item/left_hand
		item/right_hand

		list
			cooldowns = list()

		tmp
			dying = FALSE
			NPC = FALSE

	Stat()
		statpanel("Stats")
		stat("Hit Points:", hit_points)
		stat("Strength:", strength)
		stat("Mana:", mana)
		stat("Defense:", defense)
		stat("Accuracy:", "[accuracy * 100]%")
		stat("Agility:", "[agility * 100]%")
		stat("Gold:", gold)

	Bump(atom/a)
		..()
		attack(a)

	key_down(k)
		..()
		if(k == "space")
			var/turf/t = get_step(src, dir)
			for(var/v in t)
				interact(v)
		if(k == "g")
			call(/mob/verb/Get)(src)