/*
_ai.dm

this is the AI file.  this is what all enemies should branch off of.

there is a simple artificial intelligence system in the ai() proc.
i challenge you to make it better.
*/

ai
	parent_type = /mob

	var
		// Just gonna do 0 aggro for AI who waits to attack until attacked
		// 1 aggro for attack on sight
		// 1 by default
		aggro = 1

		ai_loop_delay = 3
		view_dist = 5
		mob/target

	// I don't want every battle with normal enemies dragging on forever.  Default agility for AI is bumped down to 10%
	agility = 0.1

	New()
		..()
		ai()

	ai()
		if(aggro)
			if(!target)
				for(var/player/p in oview(view_dist))
					target = pick_best_target(p)
		// Have to do this check in case they don't find a target
		if(target)
			if(get_dist(src, target) > 1)
				step(src, get_dir(src, target))
			else
				Bump(target)

		spawn(ai_loop_delay)
			ai()

	attacked(mob/attacker)
		if(!target)
			target = attacker

	// You can define this to do things like choose preference over
	// newTarget and your current target.  If newTarget has more HP
	// target it, for example.
	pick_best_target(mob/newTarget)
		return newTarget